/* by Luis Figueiredo (stdio@netc.pt)
 *
 *
 * date: Sat Mar 30 14:44:42 GMT 2002
 *
 *
 * --
 *
 */


#include "client.h"


extern char *_web_server_version; // Defined in server.c


char hdrdatem[35];
struct web_client *current_web_client;

struct web_client *init_client_list() {
	struct web_client *ret;
	IFDEBUG(fprintf(stderr,"client.c (allocating head client list): ");fflush(stderr);); // REMOVE
	ret=mymalloc(sizeof(struct web_client));
#ifdef HAVE_OPENSSL
	ret->ssl=NULL; // ssl handler for this client
#endif
	ret->next=NULL;
	return ret;
}

void add_client(struct web_client *list, struct web_client *node) {
	struct web_client *temp=list;
	while(temp->next!=NULL)temp=temp->next; // run to last client
	temp->next=node;
	temp->next->rbuf=NULL;
	temp->next->rbufsize=temp->next->writedsize=0;
	temp->next->outstream=init_outstream_list();
	temp->next->newdata_try=0;
#ifdef WIN32
	
#else
	fcntl(temp->next->socket,F_SETFL,O_NONBLOCK);
#endif
	temp->next->next=NULL;
	temp->next->HTTPdirective=NULL;
	temp->next->stat=1; // Add a connected client
	IFDEBUG(fprintf(stderr,"Client added\n"));
}
#ifdef WIN32
#define SHUT_RDWR SD_BOTH
#endif

void delete_client(struct web_client *node) {
	shutdown(node->socket,SHUT_RDWR);
	close(node->socket);
	delete_outstream_list(node->outstream);
#ifdef HAVE_OPENSSL
	SSL_free (node->ssl);
#endif
	IFDEBUG(fprintf(stderr,"client.c (freeing client->rbuf): ");fflush(stderr);); // REMOVE
	myfree(node->rbuf); // free's
	IFDEBUG(fprintf(stderr,"client.c (freeing client node): ");fflush(stderr);); // REMOVE
	myfree(node);       // free's
	IFDEBUG(fprintf(stderr,"Client delected\n"));
}

void delete_next_client(struct web_client *node) {
	struct web_client *temp=node->next;
	node->next=node->next->next;
	delete_client(temp);
}
/* 
 * Read what client have to say
 */
void read_client(struct web_client *node) {
	int tmp,tmp1;
	char readtemp[READMAX];
	int i=0;
	if(newdata(node->socket)) {

#ifdef HAVE_OPENSSL
		if(node->ssl!=NULL) {	
			tmp=SSL_read(node->ssl,readtemp,READMAX);		
		} else {
			tmp=myread(node->socket,readtemp,READMAX);
		};

#else
		tmp=myread(node->socket,readtemp,READMAX);
#endif
		if(tmp<1) {
			node->stat=5;	
			return;	
		};
		tmp1=node->rbufsize;
		node->rbufsize+=tmp;
		IFDEBUG(if(node->rbuf==NULL)fprintf(stderr,"client.c (allocating client->rbuf): ");fflush(stderr);); // REMOVE
		node->rbuf=myrealloc(node->rbuf,node->rbufsize+1);
		memcpy(node->rbuf+tmp1,readtemp,tmp);
		node->rbuf[node->rbufsize]='\0';
		node->newdata_try=0;
	}else {
		node->newdata_try++;
		if(node->rbufsize>0 && node->newdata_try>2) {  // (NEW) if pass's 2 times without giving data (4 ms i guess) then over
			IFDEBUG(fprintf(stderr,"Client all readed (%d bytes)\n",node->rbufsize));		
			IFDEBUG(fprintf(stderr,"Read :"));
			IFDEBUG(fwrite(node->rbuf,node->rbufsize,1,stderr));
			IFDEBUG(fprintf(stderr,"\n"));
			node->stat=2; // Next state
			//write(2,node->rbuf,node->rbufsize); //REMOVE DEBUG
			current_web_server->stat.brecv+=node->rbufsize; // stats
		};
	};
}
/*
 * Process headers w/ get handlers
 */
void process_client(struct web_client *node,struct gethandler *list) {
	struct gethandler *gettemp=list;
	int tmp=0;
	char *tmp1;
	char matchbuf[MATCHMAX];	
	regex_t preg;
	FILE tfile; 
	FILE *nfile;
	while(gettemp->next!=NULL && tmp==0) {
		gettemp=gettemp->next;
		snprintf(matchbuf,MATCHMAX,"%s$",gettemp->str);
		IFDEBUG(fprintf(stderr,"compiling regexp\n"));
		if(regcomp(&preg,matchbuf,REG_NOSUB|REG_ICASE|REG_EXTENDED)) {
			IFDEBUG(fprintf(stderr,"Error compiling regexp\n"));
			return;
		};
		if((tmp1=web_client_getreqline1())==NULL) {
			node->stat=5;
			IFDEBUG(fprintf(stderr,"client.c (freeing preg):\n ");fflush(stderr);); // REMOVE
			regfree(&preg);
			return;
		};
		if(strlen(tmp1)>MAXURLSIZE) {
			writef(node,"HTTP/1.1 414 URL to large\r\n");
			writef(node,"Date: %s\r\n",Hdrdate()); // Date header
			writef(node,"Server: %s\r\n",_web_server_version);
			writef(node,"Content-type: text/html\r\n\r\n<HTML><title>URL to large</title><body bgcolor=FFFFFF><font size=6>414 Requested url to large</font><BR><BR><HR><small><i>%s</i></small></body></html>\n\r",_web_server_version);                                    
			node->stat=5;
			IFDEBUG(fprintf(stderr,"client.c (freeing getreqline1): ");fflush(stderr);); // REMOVE
			myfree(tmp1);
			IFDEBUG(fprintf(stderr,"client.c (freeing preg):\n ");fflush(stderr);); // REMOVE
			regfree(&preg);
			return;
		};
		IFDEBUG(fprintf(stderr,"Matching\n"));
		if(!regexec(&preg,tmp1,0,0,0)) {
			IFDEBUG(fprintf(stderr,"It matches\n"));	
			if((gettemp->flag & WS_LOCAL) == WS_LOCAL) {
                        	if(node->sa.sin_addr.s_addr!=0x0100007F) {
                               		writef(node,"HTTP/1.1 403 Forbidden\r\n");
					writef(node,"Date: %s\r\n",Hdrdate()); // Date header
                                	writef(node,"Server: %s\r\n",_web_server_version);
                                	writef(node,"Content-type: text/html\r\n\r\n<HTML><title>Forbidden</title><body bgcolor=FFFFFF><font size=6>403 Forbidden</font><BR><small>only local host accepted</small><BR><HR><small><i>%s</i></small></body></html>\n\r",_web_server_version);
                                	web_log("%s - - [%s] Connection rejected (only accepting 127.0.0.1)\n",inet_ntoa(node->sa.sin_addr),mydate());
					node->stat=5;
					IFDEBUG(fprintf(stderr,"client.c (freeing getreqline1): ");fflush(stderr);); // REMOVE
					myfree(tmp1);
					IFDEBUG(fprintf(stderr,"client.c (freeing preg):\n ");fflush(stderr);); // REMOVE
					regfree(&preg);
                                	return;
                        	};
                	};                        
			
			tmp=1; // Was found
		};
		IFDEBUG(fprintf(stderr,"client.c (freeing getreqline1): ");fflush(stderr);); // REMOVE
		myfree(tmp1);
		IFDEBUG(fprintf(stderr,"client.c (freeing preg):\n ");fflush(stderr);); // REMOVE
		regfree(&preg);
	};	
	if(!tmp) { // Nothing found
		writef(node,"HTTP/1.1 404 Not Found\r\n");
		writef(node,"Date: %s\r\n",Hdrdate()); // Date header
		writef(node,"Server: %s\r\n",_web_server_version);
		writef(node,"Content-type: text/html\r\n\r\n<HTML><title>not found</title><body bgcolor=FFFFFF><font size=6>404 NOT FOUND</font><BR><BR><HR><small><i>%s</i></small></body></html>\n\r",_web_server_version);                                    
		node->stat=5;
	}else {
		if(node->HTTPdirective==NULL) {
			writef(node,"HTTP/1.1 200 OK\r\n");
		} else {
			writef(node,"%s\r\n",node->HTTPdirective);
		};
		writef(node,"Date: %s\r\n",Hdrdate()); // Date header
		//Date: Mon, 14 Oct 2002 19:21:25 GMT
		writef(node,"Server: %s\r\n",_web_server_version);
		nfile=tmpfile();
		if(nfile!=NULL) {
			if(!web_client_addstream(nfile)) {
				IFDEBUG(fprintf(stderr,"Couldn't add stream\n"));
			};
			tfile=*stdout;	
			*stdout=*nfile;	
			// Setup Clientinfo before running funcion
			init_clientinfo();	 // NEW
			gettemp->func();
			free_clientinfo();        // NEW

			fflush(stdout);
			*stdout=tfile;	
			fseek(nfile,0,SEEK_SET);
		};
		node->stat=4;   
	};

}

/*
 * Process stream output
 */
void output_client(struct web_client *node) {
	struct outstream *tstream=node->outstream;
	char writetemp[WRITEMAX];
	int endstream=0;
	if(tstream->next!=NULL) {
		if(tstream->next->fstream!=NULL) {
			if(tstream->next->wsize>0) {	// if last read ok
				if(tstream->next->rsize==0)fseek(tstream->next->fstream,0,SEEK_SET); // Exprimental
				tstream->next->rsize=fread(writetemp,1,WRITEMAX,tstream->next->fstream);
				IFDEBUG(fprintf(stderr,"Readed %d bytes\n",tstream->next->rsize));
			} else {
				IFDEBUG(fprintf(stderr,"wsize is less or equal than 0 (didn't read)\n"););
			};
			if(tstream->next->rsize<1)endstream=1;
			#ifdef HAVE_OPENSSL
				if(node->ssl!=NULL) {
					tstream->next->wsize=SSL_write(node->ssl,writetemp,tstream->next->rsize);
				} else {
					tstream->next->wsize=send(node->socket,writetemp,tstream->next->rsize,0);
				};
			#else		
				tstream->next->wsize=send(node->socket,writetemp,tstream->next->rsize,0);
			#endif
			IFDEBUG(fprintf(stderr,"Writed %d bytes\n",tstream->next->wsize));
			IFDEBUG(write(2,writetemp,tstream->next->wsize)); // to strerr 
			//write(2,writetemp,tstream->next->wsize); // to strerr 
			if(tstream->next->wsize>0) {
				node->writedsize+=tstream->next->wsize;	
				if(tstream->next->rsize!=tstream->next->wsize) {	
					fseek(tstream->next->fstream,node->writedsize,SEEK_SET);
					IFDEBUG(fprintf(stderr,"Seeked to %d\n",node->writedsize));
				};
			};
			if(tstream->next->wsize<=0 && errno!=11) {
				 endstream=1; // Broken pipe
			}else {
				if(tstream->next->wsize<0) {
					IFDEBUG(fprintf(stderr,"Broken pipe\n"););
				};
			};
		}else {;
			endstream=1;
		};
		if(endstream) {
			IFDEBUG(fprintf(stderr,"Delecting stream\n"));
			delete_next_outstream(tstream);
			IFDEBUG(fprintf(stderr,"next=%p\n",tstream->next));
			node->outstream->next=tstream->next;
			current_web_server->stat.bsent+=node->writedsize; // stats
			node->writedsize=0;
		};
	}else { // End of streams
		current_web_client->stat=5; // done
	};
}


/*
 * Set http directive
 */
void web_client_HTTPdirective(char *str) { 
	current_web_client->HTTPdirective=str;
}
/*
 * GET request line
 */
char *web_client_getreqline() {
	char *ret;
	char *tmp1=strstr(current_web_client->rbuf,"\r\n");
	int size=tmp1-current_web_client->rbuf;
	if(size<1) return NULL;
	IFDEBUG(fprintf(stderr,"client.c (allocating getreqline): ");fflush(stderr);); // REMOVE
	ret=mymalloc(size+1);
	memcpy(ret,current_web_client->rbuf,size);
	ret[size]=0;
	return ret;
}
char *web_client_getreqline1() {
	char *ret;
	char *tmp1=strstr(current_web_client->rbuf,"?");
	char *tmp2=strstr(current_web_client->rbuf," HTTP");
	char *tmp3=strstr(current_web_client->rbuf,"\r\n");
	int size;
	if(tmp1==NULL || tmp1>tmp2) {
		tmp1=tmp2;
	};
	if(tmp2>tmp3) {
		return NULL;
	};
	size=tmp1-current_web_client->rbuf;
	if(size<1) return NULL;
	IFDEBUG(fprintf(stderr,"client.c (allocating getreqline1): ");fflush(stderr);); // REMOVE
	ret=mymalloc(size+1);
	memcpy(ret,current_web_client->rbuf,size);
	ret[size]=0;
	return ret;

};

/*
 * Add a FILE stream type to client output
 */
int web_client_addstream(FILE *in) {
	int ret=add_outstream(current_web_client->outstream,in);
	FILE *nfile=tmpfile();
	if(nfile!=NULL) { 
		if(!add_outstream(current_web_client->outstream,nfile)) {
			IFDEBUG(fprintf(stderr,"Couldn't add stream\n"));
		};
		fflush(stdout); // flush previous stdout
		*stdout=*nfile; // give new stdout
		//current_web_client->ClientInfo->outputfd=nfile->_fileno; PROTO
	};                         	
	return ret;
	
}



char *web_client_getreqhost() {
	char *tmp1,*tmp2,*tmp3,*ret;
	int size;
	tmp1=strstr(current_web_client->rbuf,"Host: ");
	if(tmp1==NULL) {
		return NULL;
	};
	tmp1+=6;
	tmp2=strstr(tmp1,"\r\n");
	tmp3=strstr(tmp1,":");
	if(tmp3!=NULL && tmp3<tmp2) {
		tmp2=tmp3;
	};
	size=(int)(tmp2-tmp1);
	IFDEBUG(fprintf(stderr,"client.c (allocating getreqhost): ");fflush(stderr);); // REMOVE
	ret=mymalloc(size+1);
	if(ret==NULL) {
		return NULL;
	};
	memcpy(ret,tmp1,size);
	ret[size]=0;
	return ret;
}


/*
 * an util to write with format on filedescriptors
 */

void writef(struct web_client *node,const char *fmt,...) {
        va_list args;
        char buf[WRITEMAX];
        va_start(args,fmt);
        vsnprintf(buf,512,fmt,args);
        va_end(args);
        IFDEBUG(fprintf(stderr,"Writed: %s\n",buf));
#ifdef HAVE_OPENSSL        
	if(node->ssl!=NULL) {
		SSL_write(node->ssl,buf,strlen(buf));
	} else {
		send(node->socket,buf,strlen(buf),0);   
	};
#else
	send(node->socket,buf,strlen(buf),0);
#endif

}
//Date: Mon, 14 Oct 2002 19:19:14 GMT
char *Hdrdate() {
        time_t timev;
        const char *month[] = {"Jan","Fev","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dez"};
        const char *week[] = {"Sun","Mon","Tue","Wen","Thu","Fri","Sat"};
        struct tm *tm;
        timev=time(NULL);
        tm=localtime(&timev);
	tzset();
        snprintf(hdrdatem,30,"%3s, %02d %3s %04d %02d:%02d:%02d %s",week[tm->tm_wday],tm->tm_mday,month[tm->tm_mon],1900+tm->tm_year,tm->tm_hour,tm->tm_min,tm->tm_sec,tzname[0]);
        return hdrdatem;
}                 
